class MyWatcher expands SpawnNotify;

var int TM, MaxDecals, DecalCount, K;

replication
{
	// Variables the server should send to the client.
	reliable if( Role==ROLE_Authority )
		TM, MaxDecals;
}

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();
	TM = class'DsMut'.default.TimeMultiplier * 10;
	MaxDecals = class'DsMut'.default.MaxDecals;
}

simulated function CountDecals()
{
	local Scorch S;

	DecalCount = 0;
	foreach Level.allactors(class'Scorch', S)
	{
		DecalCount++;
		if ((S.LifeSpan < 1) && (S.LifeSpan != 0))
		{
			S.SetTimer(S.LifeSpan, false);
			S.LifeSpan = 0.0;
			S.Enable('Timer');
		}
	}
}

simulated event actor SpawnNotification(actor A)
{
	if ((Scorch(A) == None) || (Level.NetMode == NM_DedicatedServer))
		return A;
	K++;
	if ((K > 30) || (DecalCount < 30))  // Only update the DecalCount once every 30 scorchmarks spawned
	{
		k = 0;
		CountDecals();
	}
	if ((TM == 0) && (DecalCount < MaxDecals))
		{
			A.Disable('Timer');
			A.Lifespan = 0.0;
		}
	else if (DecalCount < MaxDecals)
		{
			if (DecalCount > 30)
			{
				A.Disable('Timer');
				A.Lifespan = TM;
			}
			else A.SetTimer(TM, false);
		}
	return A;
}

defaultproperties
{
}
